#!/usr/bin/env python

import dbus, dbus.service
from dbus.mainloop.glib import DBusGMainLoop
import gobject

class MyPasskeyAgent(dbus.service.Object) :

    def __init__(self, path):
        dbus.service.Object.__init__(self, dbus.SystemBus(), path)
    
    @dbus.service.method(dbus_interface='org.bluez.PasskeyAgent',
                         in_signature='ssb', out_signature='s')
    def Request(self, path, address, shit):
        print path, address
        return '0000'

    @dbus.service.method(dbus_interface='org.bluez.PasskeyAgent',
                         in_signature='ss', out_signature='')
    def Cancel(self, path, address):
        pass

    @dbus.service.method(dbus_interface='org.bluez.PasskeyAgent',
                         in_signature='', out_signature='')
    def Release(self):
        pass



DBusGMainLoop(set_as_default=True)

agent = MyPasskeyAgent('/org/bluez/Agent0')
sis_bus = dbus.SystemBus()
secu = dbus.Interface(sis_bus.get_object('org.bluez', '/org/bluez/hci0'), 'org.bluez.Security')
secu.RegisterDefaultPasskeyAgent('/org/bluez/Agent0')

loop = gobject.MainLoop()

loop.run()
